<?php defined('SYSPATH') or die('No direct script access.');
 
class Controller_Handler extends Controller {
    protected $user, $post, $model;
    private $access;
    
    const ACCESS_ADMIN = 0; 
    const ACCESS_TEACHER = 1; 
    const ACCESS_STUDENT = 2; 
    const ACCESS_USER = 3; 
    const ACCESS_GUEST = 4; 
    const ACCESS_ANYBODY = 5; 

    public function before()
    {
        // Если у нас запрос идет не из AJAX
        if(!$this->request->is_ajax())
        {
            // Перенаправляем на ошибку доступа
            throw HTTP_Exception::factory (403);   
        }
        
        // Обработка POST-данных
        $this->post = Validation::factory(Arr::map('trim', $_POST));
        
        // Если запрос не прошел на проверку доступа
        if(!$this->checkAccessLevel())
        {
            // Перенаправляем на ошибку доступа
            throw HTTP_Exception::factory (403);
        }
        
        if(Auth::isLoggedIn())
        {
            $model = new Model_Account;
            $user = Auth::getData();
            $this->user = $model->getPersonalInfoByID($user['ID'])->offsetGet(0);
            $this->user += $model->getAccountInfoByID($user['ID'])->offsetGet(0);
            $this->user['EMail'] = $this->user['E-Mail'];
            unset($this->user['E-Mail']);
            unset($this->user['ID']);
            unset($this->user['Type']);
        }
    }
    
    protected function setAccessLevel($level)
    {
        $level = (int) $level;
        if($level < self::ACCESS_ADMIN AND $level > self::ACCESS_ANYBODY)
            return;
        else
            $this->access = (int) $level;
    }
    
    protected function checkAccessLevel()
    {
        if ($this->access == self::ACCESS_ADMIN)
        {
            // TODO: Проверка токена и юзер-агента
            return Auth::isLoggedIn () AND $this->user['Type'] == 'admin';
        }
        elseif ($this->access == self::ACCESS_TEACHER)
        {
            // TODO: Проверка токена и юзер-агента
            return Auth::isLoggedIn () AND $this->user['Type'] == 'teacher';
        }
        elseif ($this->access == self::ACCESS_STUDENT)
        {
            // TODO: Проверка токена и юзер-агента
            return Auth::isLoggedIn () AND $this->user['Type'] == 'student';
        }
        elseif ($this->access == self::ACCESS_USER)
        {
            return Auth::isLoggedIn();
        }
        elseif ($this->access == self::ACCESS_GUEST)
        {
            return !Auth::isLoggedIn();
        }
        elseif ($this->access == self::ACCESS_ANYBODY)
        {
            return true;
        }
    }
}
