<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Teacher_Map extends Controller_UserEnvi {
    
    public function action_show()
    {
        $twig = Twig::factory('teacher/map/show');
        
        $twig->User = $this->UserInfo;
        $id = $this->request->param('id');
        $db = new Model_Teacher_Map;
        $map = $db->getMapForDiscipline($this->UserInfo['TeacherID'], $id);
        
        if($map->count() == 0)
            throw HTTP_Exception::factory(404, "Учебная карта дисциплины с ID $id не найдена!");
        
        $mapHandled = array();
        
        $maxRate = 0; $i = 0; $module = 0;
        foreach($map as $row)
        {
            if($row['ModuleID'] != $module)
            {
                $i++;
                $module = $row['ModuleID'];
            }
            if(!isset($mapHandled[$i]['SubmodulesCount']))
            {
                $mapHandled[$i]['SubmodulesCount'] = 0;
                $mapHandled[$i]['MaxRate'] = 0;
            }
            $j = $mapHandled[$i]['SubmodulesCount'] += 1;
            $mapHandled[$i]['MaxRate'] += (int) $row['MaxRate'];
            $mapHandled[$i]['ModuleTitle'] = $row['ModuleName'];
            $mapHandled[$i][$j]['Title'] = $row['SubModuleName'];
            $mapHandled[$i][$j]['Description'] = $row['SubmoduleDescription'];
            $mapHandled[$i][$j]['MaxRate'] = (int) $row['MaxRate'];
            $maxRate += $row['MaxRate'];
        }
        $mapHandled['ModulesCount'] = $i;
        $mapHandled['MaxRate'] = (int) $maxRate;        
        
        $this->map = $mapHandled;
        
        //$this->response->body($twig);
        $this->response->body('<pre>'.print_r($mapHandled, true).'</pre>');
    }
    
    public function action_create()
    {
        $twig = Twig::factory('teacher/map/construct');
        $twig->User = $this->UserInfo;
        $id = $this->request->param('id');
        
        $this->response->body($twig);
    }
    
    public function action_edit()
    {
        $twig = Twig::factory('teacher/map/construct');
        $twig->User = $this->UserInfo;
        $id = $this->request->param('id');
        $db = new Model_Teacher_Map;
        $discipline = $db->getDisciplineMap($this->UserInfo['TeacherID'], $id);
        if($discipline->count() == 0)
            throw HTTP_Exception::factory(404, "Учебная карта дисциплины с ID $id не найдена!");
        $disciplineHandled = array();
        $maxRate = 0; $i = 0; $module = 0;
        foreach($discipline as $row)
        {
            if($row['ModuleID'] != $module)
            {
                $i++;
                $module = $row['ModuleID'];
            }
            if(!isset($disciplineHandled[$i]['SubmodulesCount']))
            {
                $disciplineHandled[$i]['SubmodulesCount'] = 0;
                $disciplineHandled[$i]['MaxRate'] = 0;
            }
            $j = $disciplineHandled[$i]['SubmodulesCount'] += 1;
            $disciplineHandled[$i]['MaxRate'] += (int) $row['MaxRate'];
            $disciplineHandled[$i]['ModuleTitle'] = $row['ModuleName'];
            $disciplineHandled[$i][$j]['Title'] = $row['SubModuleName'];
            $disciplineHandled[$i][$j]['Description'] = $row['SubmoduleDescription'];
            $disciplineHandled[$i][$j]['MaxRate'] = (int) $row['MaxRate'];
            $maxRate += $row['MaxRate'];
        }
        $disciplineHandled['ModulesCount'] = $i;
        $disciplineHandled['MaxRate'] = (int) $maxRate;           
        $this->response->body($twig);
    }
}
            